Leetcode 1011. Capacity To Ship Packages Within D Days (Binary Search经典)

  1. Capacity To Ship Packages Within D Days
    Medium
    8.6K
    179
    Companies
    A conveyor belt has packages that must be shipped from one port to another within days days.

The ith package on the conveyor belt has a weight of weights[i]. Each day, we load the ship with packages on the conveyor belt (in the order given by weights). We may not load more weight than the maximum weight capacity of the ship.

Return the least weight capacity of the ship that will result in all the packages on the conveyor belt being shipped within days days.

Example 1:

Input: weights = [1,2,3,4,5,6,7,8,9,10], days = 5
Output: 15
Explanation: A ship capacity of 15 is the minimum to ship all the packages in 5 days like this:
1st day: 1, 2, 3, 4, 5
2nd day: 6, 7
3rd day: 8
4th day: 9
5th day: 10

Note that the cargo must be shipped in the order given, so using a ship of capacity 14 and splitting the packages into parts like (2, 3, 4, 5), (1, 6, 7), (8), (9), (10) is not allowed.
Example 2:

Input: weights = [3,2,2,4,1,4], days = 3
Output: 6
Explanation: A ship capacity of 6 is the minimum to ship all the packages in 3 days like this:
1st day: 3, 2
2nd day: 2, 4
3rd day: 1, 4
Example 3:

Input: weights = [1,2,3,1,1], days = 4
Output: 3
Explanation:
1st day: 1
2nd day: 2
3rd day: 3
4th day: 1, 1

Constraints:

1 <= days <= weights.length <= 5 * 104
1 <= weights[i] <= 500

解法1:binary search
注意:start 从weights的最大值开始,不要从1开始。因为capacity必须>=货物中的最大值。end其实也可以设为所有货物的weights之和。

class Solution {
    
    
public:
    int shipWithinDays(vector<int>& weights, int days) {
    
    
        int n = weights.size();
        int start = *max_element(weights.begin(), weights.end()), end = INT_MAX;
        while (start + 1 < end) {
    
    
            int mid = start + (end - start) / 2;
            if (daysNeeded(weights, mid) <= days) {
    
    
                end = mid;
            } else {
    
    
                start = mid;
            }
        }
        if (daysNeeded(weights, start) <= days) return start;
        return end;
    }
private:
    int daysNeeded(vector<int>& weights, int capacity) {
    
    
        int n = weights.size();
        int res = 0, load = 0;
        for (int i = 0; i < n; i++) {
    
    
            load += weights[i];
            if (load > capacity) {
    
    
                load = weights[i];
                res++;
            }
        }
        if (load > 0) res++;
        return res;
    }
};

猜你喜欢

转载自blog.csdn.net/roufoo/article/details/132706114